wayland::zwp_pointer_gestures_v1_t(3)

NAME
wayland::zwp_pointer_gestures_v1_t - touchpad gestures

SYNOPSIS

#include <wayland-client-protocol-unstable.hpp>

Inherits wayland::proxy_t.

  Public Types

enum class wrapper_type { standard, display, foreign, proxy_wrapper }

  Public Member Functions

zwp_pointer_gesture_swipe_v1_t get_swipe_gesture (pointer_t const &pointer)
get swipe gesture
zwp_pointer_gesture_pinch_v1_t get_pinch_gesture (pointer_t const &pointer)
get pinch gesture
void release ()
destroy the pointer gesture object
bool can_release () const
Check whether the release function is available with the currently bound version of the protocol.
zwp_pointer_gesture_hold_v1_t get_hold_gesture (pointer_t const &pointer)
get hold gesture
bool can_get_hold_gesture () const
Check whether the get_hold_gesture function is available with the currently bound version of the protocol.
uint32_t get_id () const
Get the id of a proxy object.
std::string get_class () const
Get the interface name (class) of a proxy object.
uint32_t get_version () const
Get the protocol object version of a proxy object.
wrapper_type get_wrapper_type () const
Get the type of a proxy object.
void set_queue (event_queue_t queue)
Assign a proxy to an event queue.
wl_proxy * c_ptr () const
Get a pointer to the underlying C struct.
bool proxy_has_object () const
Check whether this wrapper actually wraps an object.
operator bool () const
Check whether this wrapper actually wraps an object.
bool operator== (const proxy_t &right) const
Check whether two wrappers refer to the same object.
bool operator!= (const proxy_t &right) const
Check whether two wrappers refer to different objects.
void proxy_release ()
Release the wrapped object (if any), making this an empty wrapper.

  Static Public Attributes

static constexpr std::uint32_t get_swipe_gesture_since_version = 1
Minimum protocol version required for the get_swipe_gesture function.
static constexpr std::uint32_t get_pinch_gesture_since_version = 1
Minimum protocol version required for the get_pinch_gesture function.
static constexpr std::uint32_t release_since_version = 2
Minimum protocol version required for the release function.
static constexpr std::uint32_t get_hold_gesture_since_version = 3
Minimum protocol version required for the get_hold_gesture function.

Detailed Description

touchpad gestures

A global interface to provide semantic touchpad gestures for a given pointer.

Three gestures are currently supported: swipe, pinch, and hold. Pinch and swipe gestures follow a three-stage cycle: begin, update, end, hold gestures follow a two-stage cycle: begin and end. All gestures are identified by a unique id.

Warning! The protocol described in this file is experimental and backward incompatible changes may be made. Backward compatible changes may be added together with the corresponding interface version bump. Backward incompatible changes are done by bumping the version number in the protocol and interface names and resetting the interface version. Once the protocol is to be declared stable, the 'z' prefix and the version number in the protocol and interface names are removed and the interface version number is reset.

Definition at line 2809 of file wayland-client-protocol-unstable.hpp.

Member Enumeration Documentation

  enum class wayland::proxy_t::wrapper_type [strong], [inherited]
Underlying wl_proxy type and properties of a proxy_t that affect construction, destruction, and event handling

Enumerator

standard
    C pointer is a standard type compatible with wl_proxy*. Events are dispatched and it is destructed when the proxy_t is destructed. User data is set.

display
    C pointer is a wl_display*. No events are dispatched, wl_display_disconnect is called when the proxy_t is destructed. User data is set.

foreign
    C pointer is a standard type compatible with wl_proxy*, but another library owns it and it should not be touched in a way that could affect the operation of the other library. No events are dispatched, wl_proxy_destroy is not called when the proxy_t is destructed, user data is not touched. Consequently, there is no reference counting for the proxy_t. Lifetime of such wrappers should preferably be short to minimize the chance that the owning library decides to destroy the wl_proxy.

proxy_wrapper
    C pointer is a wl_proxy* that was constructed with wl_proxy_create_wrapper. No events are dispatched, wl_proxy_wrapper_destroy is called when the proxy_t is destroyed. Reference counting is active. A reference to the proxy_t creating this proxy wrapper is held to extend its lifetime until after the proxy wrapper is destroyed.

Definition at line 116 of file wayland-client.hpp.

Member Function Documentation

  wl_proxy * wayland::proxy_t::c_ptr () const [inherited]

Get a pointer to the underlying C struct.

Returns
    The underlying wl_proxy wrapped by this proxy_t if it exists, otherwise an exception is thrown

  bool zwp_pointer_gestures_v1_t::can_get_hold_gesture () const

Check whether the get_hold_gesture function is available with the currently bound version of the protocol.

Definition at line 6026 of file wayland-client-protocol-unstable.cpp.

  bool zwp_pointer_gestures_v1_t::can_release () const

Check whether the release function is available with the currently bound version of the protocol.

Definition at line 6014 of file wayland-client-protocol-unstable.cpp.

  std::string wayland::proxy_t::get_class () const [inherited]

Get the interface name (class) of a proxy object.

Returns
    The interface name of the object associated with the proxy

  zwp_pointer_gesture_hold_v1_t zwp_pointer_gestures_v1_t::get_hold_gesture (pointer_t const & pointer)

get hold gesture

Parameters
    pointer

Create a hold gesture object. See the wl_pointer_gesture_hold interface for details.

Definition at line 6020 of file wayland-client-protocol-unstable.cpp.

  uint32_t wayland::proxy_t::get_id () const [inherited]

Get the id of a proxy object.

Returns
    The id the object associated with the proxy

  zwp_pointer_gesture_pinch_v1_t zwp_pointer_gestures_v1_t::get_pinch_gesture (pointer_t const & pointer)

get pinch gesture

Parameters
    pointer

Create a pinch gesture object. See the wl_pointer_gesture_pinch interface for details.

Definition at line 6002 of file wayland-client-protocol-unstable.cpp.

  zwp_pointer_gesture_swipe_v1_t zwp_pointer_gestures_v1_t::get_swipe_gesture (pointer_t const & pointer)

get swipe gesture

Parameters
    pointer

Create a swipe gesture object. See the wl_pointer_gesture_swipe interface for details.

Definition at line 5995 of file wayland-client-protocol-unstable.cpp.

  uint32_t wayland::proxy_t::get_version () const [inherited]

Get the protocol object version of a proxy object. Gets the protocol object version of a proxy object, or 0 if the proxy was created with unversioned API.

A returned value of 0 means that no version information is available, so the caller must make safe assumptions about the object's real version.

display_t will always return version 0.

Returns
    The protocol object version of the proxy or 0

  wrapper_type wayland::proxy_t::get_wrapper_type () const [inline], [inherited]

Get the type of a proxy object.

Definition at line 302 of file wayland-client.hpp.

  wayland::proxy_t::operator bool () const [inherited]

Check whether this wrapper actually wraps an object.

Returns
    true if there is an underlying object, false if this wrapper is empty

  bool wayland::proxy_t::operator!= (const proxy_t & right) const [inherited]

Check whether two wrappers refer to different objects.

  bool wayland::proxy_t::operator== (const proxy_t & right) const [inherited]

Check whether two wrappers refer to the same object.

  bool wayland::proxy_t::proxy_has_object () const [inherited]

Check whether this wrapper actually wraps an object.

Returns
    true if there is an underlying object, false if this wrapper is empty

  void wayland::proxy_t::proxy_release () [inherited]

Release the wrapped object (if any), making this an empty wrapper. Note that display_t instances cannot be released this way. Attempts to do so are ignored.

Examples
foreign_display.cpp.

  void zwp_pointer_gestures_v1_t::release ()

destroy the pointer gesture object Destroy the pointer gesture object. Swipe, pinch and hold objects created via this gesture object remain valid.

Definition at line 6009 of file wayland-client-protocol-unstable.cpp.

  void wayland::proxy_t::set_queue (event_queue_t queue) [inherited]

Assign a proxy to an event queue.

Parameters
    queue The event queue that will handle this proxy

Assign proxy to event queue. Events coming from proxy will be queued in queue instead of the display's main queue.

See also: display_t::dispatch_queue().

Examples
proxy_wrapper.cpp.

Member Data Documentation

  constexpr std::uint32_t wayland::zwp_pointer_gestures_v1_t::get_hold_gesture_since_version = 3 [static], [constexpr]

Minimum protocol version required for the get_hold_gesture function.

Definition at line 2885 of file wayland-client-protocol-unstable.hpp.

  constexpr std::uint32_t wayland::zwp_pointer_gestures_v1_t::get_pinch_gesture_since_version = 1 [static], [constexpr]

Minimum protocol version required for the get_pinch_gesture function.

Definition at line 2855 of file wayland-client-protocol-unstable.hpp.

  constexpr std::uint32_t wayland::zwp_pointer_gestures_v1_t::get_swipe_gesture_since_version = 1 [static], [constexpr]

Minimum protocol version required for the get_swipe_gesture function.

Definition at line 2842 of file wayland-client-protocol-unstable.hpp.

  constexpr std::uint32_t wayland::zwp_pointer_gestures_v1_t::release_since_version = 2 [static], [constexpr]

Minimum protocol version required for the release function.

Definition at line 2867 of file wayland-client-protocol-unstable.hpp.

Author

Generated automatically by Doxygen for Wayland++ from the source code.